<template>
  <div class="flex flex-center q-mt-xl q-ml-xl q-mr-xl">
    <q-card class="my-card fit">
      <q-card-section>
        <div class="text-h4 text-bold text-grey-9" v-if="selectedRow.id">
          <span>Update User</span>
        </div>
        <div v-else class="text-h4 text-bold text-grey-9">
          <span>Add User</span>
        </div>
      </q-card-section>
      <q-separator inset />
      <q-card-section>
        <q-form
          ref="forms"
          @submit="!selectedRow.id ? addUser() : updateUser()"
        >
          <h6 class="q-mb-sm q-mt-sm q-pb-sm text-body2 text-grey-8">
            User Information
          </h6>
          <div class="row items-start q-mb-sm">
            <div class="col q-mr-md q-ml-md">
              <q-input
                type="text"
                dense
                outlined
                v-model="form.name"
                label="Name"
                lazy-rules
                :rules="inputRules"
              />
            </div>
            <div class="col q-mr-md q-ml-md">
              <q-input
                type="text"
                dense
                outlined
                v-model="form.username"
                label="Username"
                lazy-rules
                :rules="inputRules"
              />
            </div>
            <div class="col q-mr-md q-ml-md">
              <q-input
                type="email"
                dense
                outlined
                v-model="form.email"
                lazy-rules
                :rules="inputRules"
                label="Email"
              />
            </div>
          </div>
          <div class="row items-start q-mt-sm">
            <div class="col q-mr-md q-ml-md">
              <q-input
                dense
                outlined
                v-model="form.street"
                label="Street"
                lazy-rules
                :rules="inputRules"
              />
            </div>
            <div class="col q-mr-md q-ml-md">
              <q-input
                dense
                outlined
                v-model="form.suite"
                label="Suite"
                lazy-rules
                :rules="inputRules"
              />
            </div>
          </div>
          <div class="row items-start q-mt-sm">
            <div class="col q-mr-md q-ml-md">
              <q-input
                dense
                outlined
                v-model="form.city"
                label="City"
                lazy-rules
                :rules="inputRules"
              />
            </div>
            <div class="col q-mr-md q-ml-md">
              <q-input
                dense
                outlined
                v-model="form.zipcode"
                label="Zipcode"
                lazy-rules
                :rules="inputRules"
              />
            </div>
            <div class="col q-mr-md q-ml-md">
              <q-input
                dense
                outlined
                v-model="form.lat"
                label="Geo-LAT"
                lazy-rules
                :rules="inputRules"
              />
            </div>
            <div class="col q-mr-md q-ml-md">
              <q-input
                dense
                outlined
                v-model="form.lng"
                label="Geo-LNG"
                lazy-rules
                :rules="inputRules"
              />
            </div>
          </div>
          <div class="row items-start q-mt-sm">
            <div class="col q-mr-md q-ml-md">
              <q-input
                dense
                outlined
                v-model="form.phone"
                label="Phone"
                lazy-rules
                :rules="inputRules"
              />
            </div>
            <div class="col q-mr-md q-ml-md">
              <q-input
                dense
                outlined
                v-model="form.website"
                label="Website"
                lazy-rules
                :rules="inputRules"
              />
            </div>
          </div>
          <div class="row items-start q-mt-sm">
            <div class="col q-mr-md q-ml-md">
              <q-input
                dense
                outlined
                v-model="form.company"
                label="Company Name"
                lazy-rules
                :rules="inputRules"
              />
            </div>
            <div class="col q-mr-md q-ml-md">
              <q-input
                dense
                outlined
                v-model="form.catchPhrase"
                label="CatchPhrase"
                lazy-rules
                :rules="inputRules"
              />
            </div>
            <div class="col q-mr-md q-ml-md">
              <q-input
                dense
                outlined
                v-model="form.bs"
                label="BS"
                lazy-rules
                :rules="inputRules"
              />
            </div>
          </div>
          <div class="q-mt-sm q-mb-sm float-right">
            <q-btn
              type="submit"
              class="q-mb-sm text-center"
              push
              color="primary"
              size="lg"
              style="height: 20px; width: 100px"
              :loading="btnLoadingState"
              :icon="!selectedRow.id ? 'add' : 'edit'"
            />
          </div>
        </q-form>
      </q-card-section>
    </q-card>
    <q-dialog v-model="alert" persistent :content-css="{ width: '100vw' }">
      <q-card class="bg-white">
        <q-card-section class="row items-center">
          <div class="text-h4 text-center text-grey-10">Success!</div>
        </q-card-section>

        <q-card-actions align="right">
          <q-btn
            flat
            @click="redirect"
            class="bg-primary"
            color="white"
            label="OK"
          />
        </q-card-actions>
      </q-card>
    </q-dialog>
  </div>
</template>

<script>
import { ref } from "vue";
import {
  rows,
  columns,
  form,
  selectedRow,
} from "../composables/UserManagement";
import { useRouter } from "vue-router";
import axios from "axios";

export default {
  setup() {
    const router = useRouter();
    let alert = ref(false);
    let btnLoadingState = ref(false);
    const inputRules = [(val) => !!val || "Field is required"];

    const forms = ref(null);
    //add new users
    const addUser = () => {
      btnLoadingState.value = true;
      axios.post("http://localhost:3000/users", form.value).then((response) => {
        if (response.status === 200) {
          rows.value.unshift(response.data);
          form.value = {};

          forms.value.reset();
          alert.value = true;
        }
        btnLoadingState.value = false;
      });
    };
    const redirect = () => {
      router.push({ name: "list-user" });
    };

    //update user

    const updateUser = () => {
      axios
        .put(`http://localhost:3000/users/${selectedRow.value.id}`, form.value)
        .then((response) => {
          if (response.status === 200) {
            for (let i = 0; i < rows.value.length; i++) {
              if (rows.value[i].id === selectedRow.value.id) {
                rows.value[i] = response.data;
              }
            }
            form.value = {};
            selectedRow.value = {};
            forms.value.reset();
          }
        });
    };
    return {
      rows,
      columns,
      addUser,
      form,
      btnLoadingState,
      alert,
      redirect,
      selectedRow,
      updateUser,
      inputRules,
      forms,
    };
  },
};
</script>
